# -*- coding: utf-8 -*-
"""
/***************************************************************************
 FeltTegn
                                 A QGIS plugin
 Plugin makes polys from oints
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2019-11-14
        git sha              : $Format:%H$
        copyright            : (C) 2019 by Arkæologisk IT
        email                : ds@moesgaardmuseum.dk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from qgis.PyQt.QtCore import QSettings, QTranslator, QCoreApplication
from qgis.PyQt.QtGui import QIcon
from qgis.PyQt.QtWidgets import QAction
from qgis.PyQt.QtCore import QVariant
from qgis.gui import QgsFileWidget, QgsProjectionSelectionWidget

# Initialize Qt resources from file resources.py
from .resources import *
# Import the code for the dialog
from .felt_tegn_dialog import FeltTegnDialog
import os.path

import os
import csv
from operator import itemgetter

from qgis.core import (
  QgsFields,
  QgsGeometry,
  QgsPoint,
  QgsPointXY,
  QgsWkbTypes,
  QgsFeatureRequest,
  QgsDistanceArea,
  QgsPolygon,
  QgsField,
  QgsVectorFileWriter,
  QgsFeature,
  QgsVectorLayer,
  Qgis,
  QgsProject,
  QgsCoordinateReferenceSystem,
  QgsWkbTypes,
  QgsMarkerSymbol,
  QgsLineSymbol,
  QgsFillSymbol)



class FeltTegn:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'FeltTegn_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)
            QCoreApplication.installTranslator(self.translator)

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&FeltTegn')

        # Check if plugin was started the first time in current QGIS session
        # Must be set in initGui() to survive plugin reloads
        self.first_start = None

    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('FeltTegn', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            # Adds plugin icon to Plugins toolbar
            self.iface.addToolBarIcon(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/felt_tegn/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u'Digitalisér GPS-punkter'),
            callback=self.run,
            parent=self.iface.mainWindow())

        # will be set False in run()
        self.first_start = True


    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&FeltTegn'),
                action)
            self.iface.removeToolBarIcon(action)


    def run(self):
        """Run method that performs all the real work"""

        # Create the dialog with elements (after translation) and keep reference
        # Only create GUI ONCE in callback, so that it will only load when the plugin is started
        if self.first_start == True:
            self.first_start = False
            self.dlg = FeltTegnDialog()

        # Input file dialog
        ifile = self.dlg.inputTextFile
        # Enable multiple file ingest
        ifile.setStorageMode(QgsFileWidget.GetMultipleFiles)
        #Set up output directory dialog
        odir = self.dlg.outputTargetDir
        odir.setStorageMode(QgsFileWidget.GetDirectory)
        #Projection dialog
        proj = self.dlg.mQgsProjectionSelectionWidget
        proj.setCrs(QgsCoordinateReferenceSystem("EPSG:25832"))
        
        # show the dialog
        self.dlg.show()
        
        # Run the dialog event loop
        result = self.dlg.exec_()
       
        # See if OK was pressed
        if result:
            # Export file format radio butoons
            shp = self.dlg.radioButton_shp.isChecked()
            tab = self.dlg.radioButton_tab.isChecked()
            gp = self.dlg.radioButton_gp.isChecked()
            gjson = self.dlg.radioButton_gjson.isChecked()
            
            # File creation options...
            #Add files to map
            add_files = self.dlg.chk_addfiles.isChecked() 
            '''Generate output containing all points? This is optional and is
            supporting legacy users- some will just want to load the csv'''
            kote_file = self.dlg.chk_kote.isChecked() 

            # Input files
            ifile = ifile.splitFilePaths(ifile.filePath())
            
            for i in ifile:
                # Instantiate Digi class
                digit = Digi([i],kote_file=kote_file)
                
                # Export the features
                out_layers = digit.feat_export(odir.filePath(),
                                               srs=proj.crs(),
                                               shp=shp,
                                               tab=tab,
                                               gp=gp,
                                               gjson=gjson)
                
                # Add files to Qgis layers
                if add_files is True:
                    #Instatiate our artist class
                    styled = Artist()
                    
                    #sort these and get symbology
                    for l in styled.order_layers(out_layers):
                        #get layer name
                        ol = QgsVectorLayer(l[0],os.path.split(l[0])[-1].split('.')[0],"ogr")
                        
                        #Add layer to map
                        QgsProject.instance().addMapLayer(ol)
                        
                        #Append properties to renderer
                        props = ol.renderer().symbol().symbolLayer(0).properties()
                        
                        for key in l[3]:
                            props[key] = l[3][key]
                        
                        #Set symbol type & properties depending on geometry
                        geom_type = QgsWkbTypes.displayString(ol.wkbType())
                        
                        if geom_type == 'Polygon' or geom_type == 'MultiPolygon':
                            ol.renderer().setSymbol(QgsFillSymbol.createSimple(props))
                        elif geom_type == 'LineString' or geom_type == 'MultiLineString':
                            ol.renderer().setSymbol(QgsLineSymbol.createSimple(props))
                        elif geom_type == 'Point' or geom_type == 'MultiPoint':
                            ol.renderer().setSymbol(QgsMarkerSymbol.createSimple(props))
                        else:
                            pass
                        #redraw layer
                        ol.triggerRepaint()
                        #refresh legend
                        node = QgsProject.instance().layerTreeRoot().findLayer(ol.id())
                        self.iface.layerTreeView().layerTreeModel().refreshLayerLegend(node)
                        
                else:
                    out_layers
                            
class LoadData():
    """ Class to load data from a csv file"""
    def __init__(self,
                 default_codes = True, #TODO Look for an external code file?
                 codefile = None #TODO path to codefile
                 ):
        
        """List to contain data values"""
        self.data=[]
        """Codes for feature types"""
        self.codes = {}
        # Dicts to contain first and secon pass features, layers and all points
        self.feats_1st_pass = {}  
        self.feats_2nd_pass = {}
        self.layers = {}   
        self.all_points = {}
        self.errors =[]
              
        """Use default codes? if so set self.codes to use default ardigi codes.
        these are deifned as a dict with the following attributes:
             key - text string identifying code
             ...sub dict keys... 
            - lcode : if not none first letter of sting indicates point / feature.
                      e.g. A1 = Anlæg, X1= Find etc.
            - layer : output layer name to append features to
            - type : geometric type object passed to Digi class. these are:
                    poly : polygon
                    zpoly : zigzag polygon
                    upoly : delete this from intersecting polgons
                            layer from which to do this is denoted by U_******
                    spoly : split poly using other polys. Target layer denoted
                            by S_********
                    point : point
                    pline : polyline
             - pass : what stage in the iterator are these taken in?:
                 1st pass- big trenches, fyldskift etc where people stop &
                 record anlæg etc in the middle
                 2nd pass- all the normal stuff"""
                    
        if default_codes is True:
            self.codes={"-ANLG":{"lcode":"A","layer":"Anlæg","type":"poly","pass":2},
                        "-ZZANLG":{"lcode":None,"layer":"Anlæg","type":"zpoly","pass":2},
                        "-ZZANLAEG":{"lcode":None,"layer":"Anlæg","type":"zpoly","pass":2},
                        "-FYLDSKIFTE":{"lcode":None,"layer":"Anlæg","type":"poly","pass":1},
                        "-PROFIL":{"lcode":None,"layer":"Profil","type":"poly","pass":2},
                        "-VAND":{"lcode":None,"layer":"Anlæg","type":"poly","pass":2},
                        "-FELT1":{"lcode":"F","layer":"Felt","type":"zpoly","pass":1},
                        "-FELT2":{"lcode":None,"layer":"Felt","type":"poly","pass":2},
                        "-FELTUD":{"lcode":None,"layer":"U_Felt","type":"upoly","pass":2},
                        "-NIVEAU":{"lcode":None,"layer":"Snit","type":"pline","pass":2},
                        "-SNIT":{"lcode":None,"layer":"Snit","type":"pline","pass":2},
                        "-MAALEPKT":{"lcode":"M","layer":"Målepunkter","type":"point","pass":2},
                        "-PROEVE":{"lcode":"P","layer":"Prøver","type":"point","pass":2},
                        "-FUND":{"lcode":"X","layer":"Fund","type":"point","pass":2},
                        "-KOTE":{"lcode":None,"layer":"Kote","type":"point","pass":2},
                        "-BUNDKOTE":{"lcode":None,"layer":"Kote","type":"point","pass":2},
                        "-LAG":{"lcode":"L","layer":"Lag","type":"poly","pass":2},
                        "-MANUELT":{"lcode":None,"layer":"Fejl","type":"point","pass":2}}
            
            # loop through codes to check if they have aliases
            lcodes = {}
            for k in self.codes.keys():
                if not self.codes[k]["lcode"] is None:
                    # if they do add the code info under the alias
                    lcodes[self.codes[k]["lcode"]]=self.codes[k]
                  
            for d in (lcodes):
                self.codes.update(lcodes)

        else:
            ''' load code definitons from a json file. this is extra functionality 
            to be added in a bit '''
            #TODO load codefile
            pass     
    
    def parsefile(self,
                  infile, # path to source file inluding path #TODO from GUI
                  delimiter=',', # delimiter
                  xidx=0, # index for x column in source file
                  yidx=1, # index for y column in source file
                  zidx=2, # index for z column in source file
                  ididx=3, # index for point id
                  kidx=4, # index for arkdigi code
                  nidx=5, # index for notes field
                  proj = None, # TODO handle projections from GUI
                  kote_file = False):
        """
        method loads and parses file
        """
        #open file and iterate over lines
        with open(infile, 'r') as i:
            r = csv.reader(i,delimiter=delimiter)
            # restructure if needed based on args
            for row in r:
                if len(row)>0:
                    x = row[xidx]
                    y=row[yidx]
                    z=row[zidx]
                    idid =row[ididx]
                    k = row[kidx]
                    
                    #append to self.data
                    self.data.append([x,y,z,idid,k])
        # set counter
        i = 0  
        # set up list to hold points related to feature
        current = []
        #loop over data
        l = len(self.data)
        for r in self.data:
            #set feature id
            fid = None
            #set point code
            kote = None
            #set attribute
            attr = None
            # set id for all points
            idid =r[3]
           
            #if line starts with a dash it's a standard code...
            if r[4][0] == '-':
                #check for first delimiter cos people do different things 
                space = r[4].find(' ') 
                dot = r[4].find('.')
                delim = None
                # find out how it's delimited
                if dot == -1 and space == -1:
                     kote = r[4]     
                elif dot == -1 and space > 0:
                    delim = space  
                elif dot > 0 and space ==-1:
                    delim = dot 
                elif dot>0 and space>0:
                    if dot < space:
                        delim = dot   
                    else:
                        delim = space
                # slice accordingly        
                if not delim is None:
                    if not delim == len(r)-1:
                        kote = r[4][:delim]
                        fid = r[4][delim+1:]
                    else:
                        kote = r[4]
                else:
                    kote = r[4]
                    '''fall-back condition is just to take these into the code
                    if it's wrong it will get picked up by error handling when we
                    get the code'''

                if not fid is None:
                    '''split off attributes from id'''    
                    if '.' in fid:
                        fid_l = fid.split('.') 
                        fid = fid_l[0]
    
                        if len(fid_l)>2:
                            attr = ' '.join(fid_l[1:])
                        else:
                            attr = fid_l[-1]                  
            # else the code is probably denoted by the fist letter            
            else:
                kote =r[4][0]
                #assign attribute if it's htere
                if '.' in r[4]:
                    fid, attr = r[4].split('.')
                # if it's not the feature id is the feature id
                else:
                    fid = r[4]          
            # Assign feature ID if none exists
            if fid is None:
                if len(current)==0:
                    tfid = "%s_%s" %(kote,r[3])
                    #tfid = "%s" %(r[3])
                fid = tfid
                   
            # check if code is in our code list
            if kote.upper() in self.codes.keys():
                #if so retrieve code from code list
                code = self.codes[kote.upper()]  
                # get the appropriate layer from the code list
                layer = code["layer"]
                # if it's not in our list of layers create it pronto- we'll need it later
                if not layer in self.layers.keys():
                    self.layers[layer]={'type':code["type"]}    
                # append the current geometry to current feature
                current.append([float(r[0]),float(r[1]),float(r[2]),r[3]])
                
                '''check this feature against the next in the list and to see
                if it's different or the last point in file. If so we're we're
                done with this feature and we can assign output to the 1st or 2nd
                pass feature dicts'''
                last_pt = False
                if not i==l-1:
                    if self.data[i+1][4] != r[4]:
                        last_pt = True
                else:
                    last_pt = True
                    
                if last_pt is True:                    
                    # ... unless it's a first pass feature
                    #TODO -add a 'label' attribute to the dicts
                    if code["pass"] == 1:
                        # I don't trust the feature ids from these to be unique 
                        feat_id = "%s_%s" %(kote, fid)
                        # check to see if this is a new feature or a contiuation
                        if not feat_id in self.feats_1st_pass.keys():
                            #if it's new make it
                            self.feats_1st_pass[feat_id]={}
                            self.feats_1st_pass[feat_id]["code"]=code
                            self.feats_1st_pass[feat_id]["points"]=current
                            self.feats_1st_pass[feat_id]["label"]=fid
                        else:
                            #if it's not new add the points to the existing feature
                            for c in current:
                                self.feats_1st_pass[feat_id]["points"].append(c)
                        #create and add attributes for feature        
                        self.feats_1st_pass[feat_id]["attr"]=attr
                    else:
                        # if this is a second pass feature create it
                        # check first to see if it has a unique id- stones etc don't
                        if not fid in self.feats_2nd_pass.keys():
                           
                            self.feats_2nd_pass[fid] = {}
                            self.feats_2nd_pass[fid]["points"]=current
                            self.feats_2nd_pass[fid]["label"]=fid
                        else:
                            lbl = fid
                            fid = "%s_%s" %(kote, current[0][3])
                            self.feats_2nd_pass[fid] = {}
                            self.feats_2nd_pass[fid]["points"]=current
                            self.feats_2nd_pass[fid]["label"]=lbl
                            
                        # add code info and attributes    
                        self.feats_2nd_pass[fid]["code"]=code
                        self.feats_2nd_pass[fid]["attr"]=attr
                    # reset current feature cos we're on to the next
                    current = []
            
            # if we can't find the code append to errors
            # TODO- handle this much betterer- add an error collection method
            else:
                self.errors.append(r)
                           
            # increment the counter cos we done here
            i =i+1
            
            if kote_file is True:
                self.all_points[idid]={"points":[[float(r[0]),float(r[1]),float(r[2]),r[3]]],
                                       "x":float(r[0]),
                                       "y":float(r[1]),
                                       "z":float(r[2]),
                                       "punkt_id":r[3],
                                       "Fid":fid,
                                       "kote":kote,
                                       "attr":attr,
                                       "code":{"type":'point',"layer":'AllePunkter'},
                                       "label":fid}
              
                if not 'AllePunkter' in self.layers:
                    self.layers['AllePunkter']={'type':'point'}            
   
        print ("Errors", self.errors)
            
class Digi():
    """ 
    Class digtitises layers from points. 
    Seperate methods handle each type of feature to be digitised
    """
    
    def __init__(self, 
                 infiles, #list of csv files to load
                 split_files=True, #convert as seperate files or homogenise
                 case_delimiter = '_', # delimiter used in case- eg FHM12345_blah.csv
                 kote_file = False):
        
        # The layers we'll actually use
        self.layers = None
        
        # an empty dict to hold the features
        self.features = {}
        # filename
        self.fname = None
        
        #Errors
        self.errors=[]
        
        ''' This if statment is kind of redundant, but left as a hook because 
        eventually we may add the option to merge seperate files'''
        if split_files is True:
            # Loop through and load files
            for f in infiles:
                indata = LoadData()
                indata.parsefile(f, kote_file=kote_file)
                self.layers = indata.layers
                
                # Merge dictionaries containing features
                for d in (indata.feats_1st_pass,indata.feats_2nd_pass,indata.all_points): 
                    self.features.update(d) 
                
                # Generate filename template for output
                if len(os.path.split(f)[-1])>2:
                    self.fname = '_'.join(os.path.split(f)[-1].split('.')[0:-1])
                
                else:
                    self.fname=os.path.split(f)[-1].split('.')[0]
                
                self.fname = self.fname.replace(' ', '_')
                
                # Call to feature builder method to construct geometries
                self.feature_builder()
                 
    def feature_builder(self):
        '''This method is used to construct geometries from points. Loops through
        features, constructs geometries and finally modifies features is either upoly 
        or spoly are found'''
        
        # Flag for modify features
        mod_feats = False
        
        # Loop through features
        for feat in self.features:
            #The current feature
            f = self.features[feat]
            #list to contain points
            pts = []
            # append points as QGIS geometries
            for pt in f["points"]:
                pts.append(QgsPointXY(pt[0],pt[1])) 
            
            # Get feature type
            tp = f["code"]["type"]
            # get layer feature goes into
            l = f["code"]["layer"]
            
            # empty geometry
            geom = None
            
            # Pass point arrays to constructor methods depending on geometry type
            # deal with polygons
            if tp == "poly":
                if len(pts)>2:
                    geom = self.point2poly(pts)
                elif len(pts)==2:
                    geom = self.twopointpoly(pts)
                else:
                    #todo handle error nicely
                    pass
            # deal with zig-zag polys
            elif tp == "zpoly":
                geom = self.zzpoly(pts)
            # deal with points
            elif tp == "point":
                geom = self.point2point(pts)
            # deal with poly lines
            elif tp == "pline":
                geom = self.point2pline(pts)
            # deal with cutouts from polys
            elif tp == "upoly":
                geom = self.point2poly(pts)
                mod_feats = True
            #Deal with superimpostion
            #Todo- implement method
            elif tp == "spoly":
                geom = self.point2poly(pts)
                mod_feats = True
            # If this layer is not in layers add it          
            if not l in self.layers:
                self.layers[l]={}
            # Set attribute   
            attr = f["attr"]  
            label = f["label"]
            # Output constructed features
            if not l == 'AllePunkter':
                self.layers[l][feat]={"geom":geom,"attr":attr,"label":label}
            # Output all points                
            else:
                self.layers[l][feat]={"geom":geom,
                                      "x":f['x'],
                                      "y":f['y'],
                                      "z":f['z'],
                                      "punkt_id":f['punkt_id'],
                                      "Kote":f["kote"],
                                      "Fid":f['Fid'],
                                      "attr":attr}
        # Modify features if true
        if mod_feats is True:
            self.mod_features()       
            
    def mod_features(self):
        # Method for modifiying features based on intersecting geometries
        for l in self.layers:
            if self.layers[l]['type']=='upoly' or self.layers[l]['type']=='spoly':
                # Get the target layer
                target_key = l.split('_')[-1]
                target = self.layers[target_key]
                # Use this layer as the modifer
                source = self.layers[l]
                
                # loop through features and perofm a pairwise comparison
                for feat1 in target:
                    if not type(target[feat1]) is str:
                        f1_geom = target[feat1]['geom']
                        for feat2 in source: 
                            if not type(source[feat2]) is str:
                                f2_geom = source[feat2]['geom']
                                
                                # DO the two features intersect?
                                if f1_geom.intersects(f2_geom):
                                    #if so perform modification
                                    if self.layers[l]['type']=='upoly':
                                        f1_geom = f1_geom.difference(f2_geom)
                                        
                                    elif self.layers[l]['type']=='spoly':
                                        #Todo implement spoly method
                                        pass
                        '''After we've checked all geometries add the modifed 
                        geometry back to the original feature'''
                        self.layers[target_key][feat1]['geom']=f1_geom
                                           
    def feat_export(self, 
                    odir, 
                    srs, 
                    shp=True,
                    tab=False,
                    gp=False,
                    gjson=False):
        ''' Method to export features to different file formats'''
        
        # Driver name        
        dr_n = None
        # File extension
        dr_ext =None
        
        # list of output files
        o_list = []
        
        # Set driver based on checkboxes in dialog passed from FeltTegn.run()
        # Shapefile
        if shp is True:
            dr_n = "ESRI Shapefile"
            dr_ext=".shp"
        #Tab file
        elif tab is True:
            #dr_n = "MITAB"
            '''Note- MITAB doesn't work as driver name, although according to
            docs it should. Works now with "Mapinfo File" for whatever reason. 
            I don't know either'''
            dr_n = "Mapinfo File"
            dr_ext=".tab"
        #Geopackage
        elif gp is True:
            dr_n = "GPKG"
            dr_ext=".gpkg"
        #GeoJSON
        elif gjson is True:
            dr_n = "GeoJSON"
            dr_ext=".geojson"
    
        else:
            raise Exception("No output format chosen")
        
        # Loop through layers
        for l in self.layers:
            # Set filename
            name = "%s_%s" %(self.fname,l)
            #Set full output path
            ofname = os.path.join(odir,name+dr_ext)
            #Set up fields
            fields = QgsFields()
            
            # We have to handle the All points layer differntly.
            all_points = False
            
            #Todo- I don't like this being hardcoded. Change this
            if l == "AllePunkter":
                all_points = True
            
            # If it's not all points...
            if all_points is False:
                fields.append(QgsField("Nr", QVariant.String))
                fields.append(QgsField("Notes", QVariant.String))
            
            # If it is all points ...
            elif all_points is True:
                fields.append(QgsField("X", QVariant.Double))
                fields.append(QgsField("Y", QVariant.Double))
                fields.append(QgsField("Z", QVariant.Double))
                fields.append(QgsField("PtID", QVariant.String))
                fields.append(QgsField("Kote", QVariant.String))
                fields.append(QgsField("FeatID", QVariant.String))
                fields.append(QgsField("Attr", QVariant.String))
                
            # Set geometry type
            if self.layers[l]['type']=='point':
                gt=QgsWkbTypes.Point
                gt = "Point"
                
            elif self.layers[l]['type']=='pline':
                gt=QgsWkbTypes.LineString
                gt = "LineString"
            elif self.layers[l]['type']== 'poly' or self.layers[l]['type']=='zpoly':
                gt=QgsWkbTypes.Polygon
                gt = "Polygon"
            
            '''Set coordiante system and geometry type as a string for the the 
            memory layer constructor. This is silly, but it's how it works'''
            gt = "%s?crs=%s" % (gt,srs.authid())  
            
            # Construct memory layer and add fields
            tmp_layer = QgsVectorLayer(gt, l, "memory") 
            pr = tmp_layer.dataProvider()
            pr.addAttributes(fields)
            tmp_layer.updateFields()
            
            # Add features to memory layer
            for feat in self.layers[l].keys():
                if feat != 'type' and feat !='attr':
                    fet = QgsFeature()
                    fet.setGeometry(self.layers[l][feat]["geom"])
                    if all_points is False:
                        fet.setAttributes([self.layers[l][feat]["label"], self.layers[l][feat]["attr"]])
                    else:
                        fet.setAttributes([self.layers[l][feat]["x"],
                                           self.layers[l][feat]["y"],
                                           self.layers[l][feat]["z"],
                                           self.layers[l][feat]["punkt_id"],
                                           self.layers[l][feat]["Kote"],
                                           self.layers[l][feat]["Fid"],
                                           self.layers[l][feat]["attr"]])
                    pr.addFeatures([fet])
                    tmp_layer.updateExtents()

            # Set transform context for output layer
            transform_context = QgsProject.instance().transformContext()
            #Instantiate a fiel writer class with attributes
            save_options = QgsVectorFileWriter.SaveVectorOptions()
            # Set driver
            save_options.driverName = dr_n
            # Set encoding
            save_options.fileEncoding = "UTF-8"
            # Allow overwrite
            save_options.actionOnExistingFile = QgsVectorFileWriter.CreateOrOverwriteFile
            
            if tab is True:
                '''Need to set bounds for MapInfo files. Buffers by 500m to 
                avoid any potential rounding errors or issues with modifiying
                the layers later'''
                ext=tmp_layer.extent()
                '''
                xmax = int(ext.xMaximum()+500)
                ymax = int(ext.yMaximum()+500)
                xmin = int(ext.xMinimum()-500)
                ymin = int(ext.yMinimum()-500)
                '''
                xmax = ext.xMaximum()
                ymax = ext.yMaximum()
                xmin = ext.xMinimum()
                ymin = ext.yMinimum()
                
                save_options.layerOptions = ['BOUNDS=%s,%s,%s,%s' %(xmin,ymin,xmax,ymax)]
            
            # Get Qgis Version
            q_version =int(Qgis.QGIS_VERSION.split('.')[1])
            
            #Export layers
            ''' Intention here is to use the QGIS version to set the behaviour 
            depending on how the version of Qgis handles file output, as early
            desting indicated incomaptiblity with version 3.10. However- seem to 
            fine with 3.10.3.'''
            if q_version >= 12:
                error = QgsVectorFileWriter.writeAsVectorFormatV2(tmp_layer,
                                                                   ofname,
                                                                   transform_context,
                                                                   save_options)
                
            else:
                print ('OLD METHOD!')
                error = QgsVectorFileWriter.writeAsVectorFormat(layer=tmp_layer,
                                                                fileName=ofname,
                                                                options=save_options)
                                                                  
                        
            if error[0] == QgsVectorFileWriter.NoError:
                print("success!")
            else:
                print(error)
             
            # Tidy up cos we cant trust GC
            del error
            del tmp_layer
            
            # Append to list of output files
            if not self.layers[l]['type']== 'upoly' or self.layers[l]['type']=='spoly':
                o_list.append([ofname,l])
            
        return o_list       
        
    #******************** GENERIC METHODS *************************************
    ''' These are all the geometry constructors'''
    def point2poly(self,points):
        """ internal method to take geometry and spit out a polygon """
        ring = QgsGeometry.fromPolygonXY([points])     
        
        return ring
    
    def point2pline(self,points):
        """ internal method to take geometry and spit out a polyline """
        ln = QgsGeometry.fromPolylineXY(points)
        
        return ln
    
    def point2point(self,point):
        p1 = QgsGeometry.fromPointXY(point[0])
        
        return p1
 
    def zzpoly(self,points):
        """
        method for digitising polygons on long linear features such as trial
        trenches and drains in a 'zigzag' order.
        take points as list, then re-order alternating points by taking the left 
        and right sides by splitting the ist of points into odd and even indices, 
        then reversing the order of the evens and rejoining the two lists forming 
        a ring.
        """
        # extract the odd and even points from the list. 
        odds = points[0::2]
        evens = points[1::2] 
        # Reverse the order of the even points
        evens.reverse()
        #Join the lists
        pts = odds + evens
        # Create polygon
        poly = self.point2poly(pts)
        return poly
        
    def twopointpoly(self,points):
        """
        method spits out a circle from two points on perimiter of feature. 
        """
        # Generate a line geometry from the two points
        ln = self.point2pline(points)
        # Find the radius of the circle as half the line length  
        d = ln.length()/2
        #Find the centroid of the line
        c = ln.centroid()
        # Buffer around the centroid using the calculated radius
        poly = c.buffer(d,25)
        
        return poly
    
class Artist():
    ''' Class orders layers and sets up symbology before we add them to the map canvas.'''
    # Todo- set this up to read a local symbol file 
    def __init__(self,
                 layer_def=None):
        
        self.layer_def = layer_def
        
        if self.layer_def is None:
            self.layer_def = {"Felt":{'do':0,"style":{'border_width_map_unit_scale': '3x:0,0,0,0,0,0', 'color': '243,235,219,255', 'joinstyle': 'bevel', 'offset': '0,0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_color': '35,35,35,255', 'outline_style': 'dash dot', 'outline_width': '0.26', 'outline_width_unit': 'MM', 'style': 'solid'}},
                              "Anlæg":{'do':1,"style":{'border_width_map_unit_scale': '3x:0,0,0,0,0,0', 'color': '158,158,158,255', 'joinstyle': 'bevel', 'offset': '0,0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_color': '35,35,35,255', 'outline_style': 'solid', 'outline_width': '0.06', 'outline_width_unit': 'MM', 'style': 'solid'}},
                              "Snit":{'do':3, "style":{'capstyle': 'square', 'customdash': '5;2', 'customdash_map_unit_scale': '3x:0,0,0,0,0,0', 'customdash_unit': 'MM', 'draw_inside_polygon': '0', 'joinstyle': 'bevel', 'line_color': '227,24,16,255', 'line_style': 'solid', 'line_width': '0.26', 'line_width_unit': 'MM', 'offset': '0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'ring_filter': '0', 'use_custom_dash': '0', 'width_map_unit_scale': '3x:0,0,0,0,0,0'}},
                              "Lag":{'do':2,"style":{'border_width_map_unit_scale': '3x:0,0,0,0,0,0', 'color': '133,104,69,255', 'joinstyle': 'bevel', 'offset': '0,0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_color': '35,35,35,255', 'outline_style': 'solid', 'outline_width': '0.06', 'outline_width_unit': 'MM', 'style': 'solid'}},
                              "Kote":{'do':3,"style":{'angle': '0', 'color': '0,0,0,255', 'horizontal_anchor_point': '1', 'joinstyle': 'bevel', 'name': 'circle', 'offset': '0,0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_color': '255,255,255,255', 'outline_style': 'solid', 'outline_width': '0.4', 'outline_width_map_unit_scale': '3x:0,0,0,0,0,0', 'outline_width_unit': 'MM', 'scale_method': 'diameter', 'size': '2', 'size_map_unit_scale': '3x:0,0,0,0,0,0', 'size_unit': 'MM', 'vertical_anchor_point': '1'}},
                              "Fund":{'do':3,"style":{'angle': '0', 'color': '251,154,153,255', 'horizontal_anchor_point': '1', 'joinstyle': 'bevel', 'name': 'cross2', 'offset': '0,0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_color': '0,0,0,255', 'outline_style': 'solid', 'outline_width': '0', 'outline_width_map_unit_scale': '3x:0,0,0,0,0,0', 'outline_width_unit': 'MM', 'scale_method': 'area', 'size': '2', 'size_map_unit_scale': '3x:0,0,0,0,0,0', 'size_unit': 'MM', 'vertical_anchor_point': '1'}},
                              "Prøver":{'do':3,"style":{'angle': '0', 'color': '84,176,74,255', 'horizontal_anchor_point': '1', 'joinstyle': 'bevel', 'name': 'circle', 'offset': '0,0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_color': '61,128,53,255', 'outline_style': 'solid', 'outline_width': '0.4', 'outline_width_map_unit_scale': '3x:0,0,0,0,0,0', 'outline_width_unit': 'MM', 'scale_method': 'diameter', 'size': '4', 'size_map_unit_scale': '3x:0,0,0,0,0,0', 'size_unit': 'MM', 'vertical_anchor_point': '1'}},
                              "Målepunkter":{'do':3,"style":{'angle': '0', 'color': '172,154,251,255', 'horizontal_anchor_point': '1', 'joinstyle': 'bevel', 'name': 'triangle', 'offset': '0,0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_color': '0,0,0,255', 'outline_style': 'solid', 'outline_width': '0', 'outline_width_map_unit_scale': '3x:0,0,0,0,0,0', 'outline_width_unit': 'MM', 'scale_method': 'area', 'size': '1.6', 'size_map_unit_scale': '3x:0,0,0,0,0,0', 'size_unit': 'MM', 'vertical_anchor_point': '1'}},
                              "Niveau":{'do':3,"style":{'angle': '0', 'color': '255,255,255,255', 'horizontal_anchor_point': '1', 'joinstyle': 'bevel', 'name': 'triangle', 'offset': '0,-0.20000000000000001', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_color': '0,0,0,255', 'outline_style': 'solid', 'outline_width': '0', 'outline_width_map_unit_scale': '3x:0,0,0,0,0,0', 'outline_width_unit': 'MM', 'scale_method': 'area', 'size': '2.4', 'size_map_unit_scale': '3x:0,0,0,0,0,0', 'size_unit': 'MM', 'vertical_anchor_point': '1'}},
                              "Vand":{'do':2,"style":{'angle': '135', 'color': '0,0,239,255', 'distance': '2', 'distance_map_unit_scale': '3x:0,0,0,0,0,0', 'distance_unit': 'MM', 'line_width': '0.26', 'line_width_map_unit_scale': '3x:0,0,0,0,0,0', 'line_width_unit': 'MM', 'offset': '0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_width_map_unit_scale': '3x:0,0,0,0,0,0', 'outline_width_unit': 'MM'}},
                              "Profil":{'do':3,"style":{'border_width_map_unit_scale': '3x:0,0,0,0,0,0', 'color': '133,104,69,255', 'joinstyle': 'bevel', 'offset': '0,0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_color': '35,35,35,255', 'outline_style': 'solid', 'outline_width': '0.06', 'outline_width_unit': 'MM', 'style': 'solid'}},
                              "Fyldskifte":{'do':2,"style":{'angle': '45', 'color': '108,59,0,255', 'distance': '2', 'distance_map_unit_scale': '3x:0,0,0,0,0,0', 'distance_unit': 'MM', 'line_width': '0.26', 'line_width_map_unit_scale': '3x:0,0,0,0,0,0', 'line_width_unit': 'MM', 'offset': '0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_width_map_unit_scale': '3x:0,0,0,0,0,0', 'outline_width_unit': 'MM'}},
                              "AllePunkter":{'do':2,"style":{'angle': '0', 'color': '65,65,65,255', 'horizontal_anchor_point': '1', 'joinstyle': 'bevel', 'name': 'circle', 'offset': '0,0', 'offset_map_unit_scale': '3x:0,0,0,0,0,0', 'offset_unit': 'MM', 'outline_color': '255,255,255,255', 'outline_style': 'no', 'outline_width': '0.4', 'outline_width_map_unit_scale': '3x:0,0,0,0,0,0', 'outline_width_unit': 'MM', 'scale_method': 'diameter', 'size': '0.6', 'size_map_unit_scale': '3x:0,0,0,0,0,0', 'size_unit': 'MM', 'vertical_anchor_point': '1'}}}

    def order_layers(self, out_layers):
        draw_list = []
        
        for layer in out_layers:
            l = layer[1]
            o = layer[0]
            draw_list.append((o,l,self.layer_def[l]["do"],self.layer_def[l]["style"]))
            
        draw_list.sort(key=itemgetter(2))
            
        return draw_list
            
        
            